diff --git a/src/main/java/net/minecraft/core/net/command/servercommands/SayCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/SayCommand.java
index 92ad1a49b..413ab441a 100644
--- a/src/main/java/net/minecraft/core/net/command/servercommands/SayCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/SayCommand.java
@@ -24,7 +24,7 @@ public class SayCommand extends ServerCommand {
         }
         String message = messageBuilder.toString().trim();
 
-        MinecraftServer.logger.info("[" + senderName + "] " + message);
+        MinecraftServer.LOGGER.info("[" + senderName + "] " + message);
         server.playerList.sendPacketToAllPlayers(new ChatPacket(TextFormatting.PINK + "[Server] " + message));
 
         return true;
diff --git a/src/main/java/net/minecraft/core/net/command/servercommands/ScoreCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/ScoreCommand.java
index 29f7c88a4..af1d06567 100644
--- a/src/main/java/net/minecraft/core/net/command/servercommands/ScoreCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/ScoreCommand.java
@@ -29,7 +29,7 @@ public class ScoreCommand extends ServerCommand
             int newScore = Integer.parseInt(args[2]);
 
             player.score = newScore;
-            server.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
+            server.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
             sender.sendMessage("Set " + player.getDisplayName() + TextFormatting.WHITE + "'s score to " + player.score);
             handler.sendMessageToPlayer(player, "Your score was set to " + player.score);
             return true;
@@ -42,7 +42,7 @@ public class ScoreCommand extends ServerCommand
         if (args[1].equalsIgnoreCase("reset"))
         {
             player.score = 0;
-            server.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
+            server.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
             sender.sendMessage("Set " + player.getDisplayName() + TextFormatting.WHITE + "'s score to " + player.score);
             handler.sendMessageToPlayer(player, "Your score was set to " + player.score);
             return true;
diff --git a/src/main/java/net/minecraft/core/net/command/servercommands/WhitelistCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/WhitelistCommand.java
index 004979ab6..560e608a2 100644
--- a/src/main/java/net/minecraft/core/net/command/servercommands/WhitelistCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/WhitelistCommand.java
@@ -3,9 +3,12 @@ package net.minecraft.core.net.command.servercommands;
 import net.minecraft.core.net.command.CommandHandler;
 import net.minecraft.core.net.command.CommandSender;
 import net.minecraft.core.net.command.ServerCommand;
+import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.server.MinecraftServer;
+import net.minecraft.server.entity.player.ServerPlayer;
 
 import java.util.Set;
+import java.util.UUID;
 
 public class WhitelistCommand extends ServerCommand {
     public WhitelistCommand(MinecraftServer server) {
@@ -31,10 +34,10 @@ public class WhitelistCommand extends ServerCommand {
                 server.propertyManager.setProperty("white-list", false);
                 return true;
             case "list":
-                Set<String> set = server.playerList.getWhitelist();
+                Set<UUID> set = server.playerList.getWhitelist();
                 StringBuilder builder = new StringBuilder();
-                for (String s6 : set) {
-                    builder.append("\"").append(s6).append("\"").append(", ");
+                for (UUID uuid : set) {
+                    builder.append("\"").append(uuid).append("\"").append(", ");
                 }
 
                 String message = builder.toString();
@@ -44,18 +47,38 @@ public class WhitelistCommand extends ServerCommand {
 
                 sender.sendMessage("White-listed players: " + message);
                 return true;
-            case "add":
+            case "add":{
                 if (args.length != 2) return false;
                 String nameToAdd = args[1].toLowerCase();
-                server.playerList.addToWhiteList(nameToAdd);
-                sendNoticeToOps(senderName, "Added " + nameToAdd + " to white-list");
+
+                ServerPlayer player = server.playerList.getPlayerEntity(nameToAdd);
+                if(player != null) {
+                    server.playerList.addToWhiteList(player.uuid);
+                    sendNoticeToOps(senderName, "Added " + nameToAdd + " to white-list");
+                } else {
+                    UUIDHelper.runConversionAction(nameToAdd, (uuid) -> {
+                        server.playerList.addToWhiteList(uuid);
+                        sendNoticeToOps(senderName, "Added " + nameToAdd + " to white-list");
+                    }, (username) -> handler.sendCommandFeedback(sender,"Could not retrieve UUID of player '" + username + "'"));
+                }
                 return true;
-            case "remove":
+            }
+            case "remove": {
                 if (args.length != 2) return false;
                 String nameToRemove = args[1].toLowerCase();
-                server.playerList.removeFromWhiteList(nameToRemove);
-                sendNoticeToOps(senderName, "Removed " + nameToRemove + " from white-list");
+
+                ServerPlayer player = server.playerList.getPlayerEntity(nameToRemove);
+                if(player != null) {
+                    server.playerList.removeFromWhiteList(player.uuid);
+                    sendNoticeToOps(senderName, "Removed " + nameToRemove + " from white-list");
+                } else {
+                    UUIDHelper.runConversionAction(nameToRemove, (uuid) -> {
+                        server.playerList.removeFromWhiteList(uuid);
+                        sendNoticeToOps(senderName, "Removed " + nameToRemove + " from white-list");
+                    }, (username) -> handler.sendCommandFeedback(sender,"Could not retrieve UUID of player '" + username + "'"));
+                }
                 return true;
+            }
             case "reload":
                 server.playerList.reloadWhiteList();
                 sendNoticeToOps(senderName, "Reloaded white-list from file");
diff --git a/src/main/java/net/minecraft/core/net/packet/AddPlayerPacket.java b/src/main/java/net/minecraft/core/net/packet/AddPlayerPacket.java
index fcbcfce32..0e875ab74 100644
--- a/src/main/java/net/minecraft/core/net/packet/AddPlayerPacket.java
+++ b/src/main/java/net/minecraft/core/net/packet/AddPlayerPacket.java
@@ -6,6 +6,7 @@ import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.util.helper.MathHelper;
 
 import java.io.*;
+import java.util.UUID;
 
 // Referenced classes of package net.minecraft.src:
 //            Packet, Player, MathHelper, InventoryPlayer,
@@ -22,6 +23,7 @@ public class AddPlayerPacket extends Packet
     {
         entityId = entityplayer.id;
         name = entityplayer.username;
+        uuid = entityplayer.uuid;
         xPosition = MathHelper.floor(entityplayer.x * 32D);
         yPosition = MathHelper.floor(entityplayer.y * 32D);
         zPosition = MathHelper.floor(entityplayer.z * 32D);
@@ -39,6 +41,7 @@ public class AddPlayerPacket extends Packet
     {
         entityId = dis.readInt();
         name = readString(dis, 16);
+        uuid = readUUID(dis);
         xPosition = dis.readInt();
         yPosition = dis.readInt();
         zPosition = dis.readInt();
@@ -55,6 +58,7 @@ public class AddPlayerPacket extends Packet
     {
         dos.writeInt(entityId);
         writeString(name, dos);
+        writeUUID(uuid, dos);
         dos.writeInt(xPosition);
         dos.writeInt(yPosition);
         dos.writeInt(zPosition);
@@ -79,6 +83,7 @@ public class AddPlayerPacket extends Packet
 
     public int entityId;
     public String name;
+    public UUID uuid;
     public int xPosition;
     public int yPosition;
     public int zPosition;
diff --git a/src/main/java/net/minecraft/core/net/packet/ContainerAckPacket.java b/src/main/java/net/minecraft/core/net/packet/ContainerAckPacket.java
index 4b29d83ce..499911949 100644
--- a/src/main/java/net/minecraft/core/net/packet/ContainerAckPacket.java
+++ b/src/main/java/net/minecraft/core/net/packet/ContainerAckPacket.java
@@ -14,11 +14,11 @@ public class ContainerAckPacket extends Packet
     {
     }
 
-    public ContainerAckPacket(int i, short word0, boolean flag)
+    public ContainerAckPacket(int windowId, short shortWindowId, boolean accepted)
     {
-        windowId = i;
-        shortWindowId = word0;
-        accepted = flag;
+        this.windowId = windowId;
+        this.shortWindowId = shortWindowId;
+        this.accepted = accepted;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/net/packet/LoginPacket.java b/src/main/java/net/minecraft/core/net/packet/LoginPacket.java
index 70005a373..e0004ee50 100644
--- a/src/main/java/net/minecraft/core/net/packet/LoginPacket.java
+++ b/src/main/java/net/minecraft/core/net/packet/LoginPacket.java
@@ -3,6 +3,7 @@ package net.minecraft.core.net.packet;
 import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
+import java.util.UUID;
 
 // Referenced classes of package net.minecraft.src:
 //            Packet, PacketHandler
@@ -11,6 +12,7 @@ public class LoginPacket extends Packet
 {
     public int playerEntityIdAndProtocolVersion;
     public String username;
+    public UUID uuid;
     public long worldSeed;
     public byte dimensionId;
     public byte worldTypeId;
@@ -21,9 +23,10 @@ public class LoginPacket extends Packet
     {
     }
 
-    public LoginPacket(String username, int playerEntityIdOrProtocolVersion, long worldSeed, byte dimensionId, byte worldTypeId, int packetDelay, String publicKey)
+    public LoginPacket(String username, UUID uuid, int playerEntityIdOrProtocolVersion, long worldSeed, byte dimensionId, byte worldTypeId, int packetDelay, String publicKey)
     {
         this.username = username;
+        this.uuid = uuid;
         this.playerEntityIdAndProtocolVersion = playerEntityIdOrProtocolVersion;
         this.worldSeed = worldSeed;
         this.dimensionId = dimensionId;
@@ -32,11 +35,12 @@ public class LoginPacket extends Packet
         this.publicKey = publicKey;
     }
 
-    public LoginPacket(String s, int i, String p)
+    public LoginPacket(String username, UUID uuid, int i, String publicKey)
     {
-        username = s;
-        playerEntityIdAndProtocolVersion = i;
-        publicKey = p;
+        this.username = username;
+        this.uuid = uuid;
+        this.playerEntityIdAndProtocolVersion = i;
+        this.publicKey = publicKey;
     }
 
     @Override
@@ -45,6 +49,7 @@ public class LoginPacket extends Packet
     {
         playerEntityIdAndProtocolVersion = dis.readInt();
         username = readString(dis, 16);
+        uuid = readUUID(dis);
         publicKey = readString(dis, 392);
         worldSeed = dis.readLong();
         dimensionId = dis.readByte();
@@ -58,6 +63,7 @@ public class LoginPacket extends Packet
     {
         dos.writeInt(playerEntityIdAndProtocolVersion);
         writeString(username, dos);
+        writeUUID(uuid, dos);
         writeString(publicKey, dos);
         dos.writeLong(worldSeed);
         dos.writeByte(dimensionId);
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet.java b/src/main/java/net/minecraft/core/net/packet/Packet.java
index bca82d732..f11ea80bd 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet.java
+++ b/src/main/java/net/minecraft/core/net/packet/Packet.java
@@ -1,9 +1,12 @@
 package net.minecraft.core.net.packet;
 
+import com.mojang.logging.LogUtils;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.NbtIo;
 import net.minecraft.core.Global;
 import net.minecraft.core.net.handler.PacketHandler;
+import org.slf4j.Logger;
+import org.jetbrains.annotations.NotNull;
 
 import java.io.ByteArrayInputStream;
 import java.io.ByteArrayOutputStream;
@@ -19,9 +22,11 @@ import java.util.HashSet;
 import java.util.List;
 import java.util.Map;
 import java.util.Set;
+import java.util.UUID;
 
 public abstract class Packet
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     private static final List<Integer> INTERESTING_PACKETS = Arrays.asList(50, 51, 52);
     private static final Map<Integer, Class<? extends Packet>> packetIdToClassMap = new HashMap<>();
     private static final Map<Class<? extends Packet>, Integer> packetClassToIdMap = new HashMap<>();
@@ -53,8 +58,8 @@ public abstract class Packet
     }
 
     public static Packet getNewPacket(int id) {
+        Class<? extends Packet> packetClass = packetIdToClassMap.get(id);
         try {
-            Class<? extends Packet> packetClass = packetIdToClassMap.get(id);
             if (packetClass == null) {
                 return null;
             }
@@ -63,9 +68,9 @@ public abstract class Packet
             }
         }
         catch (Exception exception) {
-            exception.printStackTrace();
+            LOGGER.error("Exception instancing packet class '{}'!", packetClass.getSimpleName(), exception);
         }
-        System.out.println("Skipping packet with id " + id);
+        LOGGER.warn("Skipping packet with id {}", id);
         return null;
     }
 
@@ -95,14 +100,14 @@ public abstract class Packet
             if (Global.NET_DEBUG) {
                 long sendTime = dis.readLong();
                 if (INTERESTING_PACKETS.contains(id)) {
-                    System.out.println("Packet " + id + " took " + (System.currentTimeMillis() - sendTime) + "ms to arrive");
+                    LOGGER.debug("Packet {} took {}ms to arrive", id, System.currentTimeMillis() - sendTime);
                 }
             }
             packet.read(dis);
         }
         catch (EOFException eofexception)
         {
-            System.out.println("Reached end of stream");
+            LOGGER.warn("Reached end of stream");
             return null;
         }
         return packet;
@@ -210,6 +215,17 @@ public abstract class Packet
         return NbtIo.readCompressed(new ByteArrayInputStream(data));
     }
 
+    public static void writeUUID(@NotNull UUID uuid, DataOutputStream dos) throws IOException {
+        dos.writeLong(uuid.getMostSignificantBits());
+        dos.writeLong(uuid.getLeastSignificantBits());
+    }
+
+    public static UUID readUUID(DataInputStream dis) throws IOException {
+        long msb = dis.readLong();
+        long lsb = dis.readLong();
+        return new UUID(msb, lsb);
+    }
+
     public static Map<Class<? extends Packet>, Integer> getPacketClassToIdMap() {
         return Collections.unmodifiableMap(packetClassToIdMap);
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/UpdatePlayerProfilePacket.java b/src/main/java/net/minecraft/core/net/packet/UpdatePlayerProfilePacket.java
index 6d50b13b8..69be2e80f 100644
--- a/src/main/java/net/minecraft/core/net/packet/UpdatePlayerProfilePacket.java
+++ b/src/main/java/net/minecraft/core/net/packet/UpdatePlayerProfilePacket.java
@@ -6,6 +6,7 @@ import net.minecraft.server.util.helper.PlayerList;
 import java.io.DataInputStream;
 import java.io.DataOutputStream;
 import java.io.IOException;
+import java.util.UUID;
 
 // Referenced classes of package net.minecraft.src:
 //            Packet, PacketHandler
@@ -17,10 +18,11 @@ public class UpdatePlayerProfilePacket extends Packet
     {
     }
 
-    public UpdatePlayerProfilePacket(String username, String nickname, int score, byte chatColor, boolean isOnline, boolean isOperator)
+    public UpdatePlayerProfilePacket(String username, String nickname, UUID uuid, int score, byte chatColor, boolean isOnline, boolean isOperator)
     {
         this.username = username;
         this.nickname = nickname;
+        this.uuid = uuid;
         this.score = score;
         this.chatColor = chatColor;
         this.isOnline = isOnline;
@@ -34,6 +36,7 @@ public class UpdatePlayerProfilePacket extends Packet
     {
         username = readString(dis, 16);
         nickname = readString(dis, 32);
+        uuid = readUUID(dis);
         score = dis.readInt();
         chatColor = dis.readByte();
         isOnline = dis.readBoolean();
@@ -46,6 +49,7 @@ public class UpdatePlayerProfilePacket extends Packet
     {
         writeString(username, dos);
         writeString(nickname, dos);
+        writeUUID(uuid, dos);
         dos.writeInt(score);
         dos.writeByte(chatColor);
         dos.writeBoolean(isOnline);
@@ -66,6 +70,7 @@ public class UpdatePlayerProfilePacket extends Packet
 
     public String username;
     public String nickname;
+    public UUID uuid;
     public int score;
     public byte chatColor;
     public boolean isOnline;
diff --git a/src/main/java/net/minecraft/core/player/Session.java b/src/main/java/net/minecraft/core/player/Session.java
index faca8af03..e5ff6ca58 100644
--- a/src/main/java/net/minecraft/core/player/Session.java
+++ b/src/main/java/net/minecraft/core/player/Session.java
@@ -1,13 +1,20 @@
 package net.minecraft.core.player;
 
+import net.minecraft.core.util.helper.UUIDHelper;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.UUID;
+
 public class Session
 {
 
-    public String username;
-    public String sessionId;
-    public Session(String username, String sessionId)
+    public @NotNull String username;
+    public @NotNull UUID uuid;
+    public @NotNull String sessionId;
+    public Session(@NotNull String username, @NotNull String uuid, @NotNull String sessionId)
     {
         this.username = username;
+        this.uuid = UUID.fromString(UUIDHelper.untrimUUID(uuid));
         this.sessionId = sessionId;
     }
 
diff --git a/src/main/java/net/minecraft/core/player/inventory/menu/AbstractContainerMenu.java b/src/main/java/net/minecraft/core/player/inventory/menu/AbstractContainerMenu.java
index dcc408947..9501fb09a 100644
--- a/src/main/java/net/minecraft/core/player/inventory/menu/AbstractContainerMenu.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/AbstractContainerMenu.java
@@ -2,6 +2,7 @@ package net.minecraft.core.player.inventory.menu;
 
 import java.util.*;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.Global;
 import net.minecraft.core.crafting.ContainerListener;
@@ -14,10 +15,11 @@ import net.minecraft.core.player.inventory.container.Inventory;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.player.inventory.slot.ResultSlot;
 import net.minecraft.core.util.helper.MathHelper;
+import org.slf4j.Logger;
 
 public abstract class AbstractContainerMenu
 {
-
+	private static final Logger LOGGER = LogUtils.getLogger();
 	public List<ItemStack> lastSlots;
 	public List<Slot> slots;
 	public int containerId;
@@ -117,7 +119,7 @@ public abstract class AbstractContainerMenu
 	public ItemStack clicked(InventoryAction action, int[] args, Player player) {
 		if(action.requireCreative()) {
 			if(player.getGamemode().consumeBlocks()) {
-				System.out.println("Player "+player.username+" used a creative inventory action but is not in creative mode!");
+                LOGGER.warn("Player {} used a creative inventory action but is not in creative mode!", player.username);
 				return null;
 			}
 		}
diff --git a/src/main/java/net/minecraft/core/sound/SoundTypes.java b/src/main/java/net/minecraft/core/sound/SoundTypes.java
index 5d0b32222..3cbd2bef3 100644
--- a/src/main/java/net/minecraft/core/sound/SoundTypes.java
+++ b/src/main/java/net/minecraft/core/sound/SoundTypes.java
@@ -1,5 +1,12 @@
 package net.minecraft.core.sound;
 
+import com.b100.utils.StringUtils;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonParser;
+
+import java.io.InputStream;
 import java.util.HashMap;
 import java.util.Map;
 import java.util.Map.Entry;
@@ -17,73 +24,27 @@ public class SoundTypes {
 	 * Required for any sound that is supposed to be played by the server
 	 */
 	public static void registerSounds() {
-		register("ambient.cave.cave");
-		register("ambient.weather.thunder");
-		register("ambient.weather.rain");
-
-		register("mob.skeleton");
-		register("mob.skeletonhurt");
-		register("mob.spider");
-		register("mob.spiderdeath");
-		register("mob.slime");
-		register("mob.slimeattack");
-		register("mob.ghast.charge");
-		register("mob.ghast.death");
-		register("mob.ghast.fireball");
-		register("mob.ghast.moan");
-		register("mob.ghast.scream");
-		register("mob.zombiepig.zpig");
-		register("mob.zombiepig.zpighurt");
-		register("mob.zombiepig.zpigdeath");
-		register("mob.zombie");
-		register("mob.zombiehurt");
-		register("mob.zombiedeath");
-
-		register("mob.chicken");
-		register("mob.chickenhurt");
-		register("mob.chickendeath");
-		register("mob.chickenplop");
-		register("mob.creeper");
-		register("mob.creeperdeath");
-		register("mob.pig");
-		register("mob.pigdeath");
-		register("mob.sheep");
-		register("mob.slime");
-		register("mob.cow");
-		register("mob.cowhurt");
-		register("mob.wolf");
-		register("mob.wolf.bark");
-		register("mob.wolf.hurt");
-		register("mob.wolf.shake");
-		register("mob.wolf.panting");
-		register("mob.wolf.death");
-		register("mob.wolf.whine");
-		register("mob.wolf.growl");
+		loadSoundsJson("/assets/minecraft/sounds/sounds.json");
+	}
 
-		register("random.bow");
-		register("random.breath");
-		register("random.click");
-		register("random.drr");
-		register("random.door_open");
-		register("random.door_close");
-		register("random.explode");
-		register("random.fizz");
-		register("random.fuse");
-		register("random.hurt");
-		register("random.pop");
-		register("random.splash");
+	public static void loadSoundsJson(String path) {
+		JsonObject o;
+		try {
+			o = loadStreamAsElement(SoundTypes.class.getResourceAsStream(path)).getAsJsonObject();
+		} catch (Exception e) {
+			System.err.println("Failed to load '" + path + "' as a json!");
+			e.printStackTrace();
+			return;
+		}
+		for (String s : o.asMap().keySet()) {
+			register(s);
+		}
+	}
 
-		register("step.cloth");
-		register("step.grass");
-		register("step.gravel");
-		register("step.stone");
-		register("step.sand");
-		register("step.wood");
-		
-		register("tile.piston.in");
-		register("tile.piston.out");
+	private static JsonElement loadStreamAsElement(InputStream stream) throws JsonParseException {
+		return JsonParser.parseString(StringUtils.readInputString(stream));
 	}
-	
+
 	public static boolean register(String soundPath) {
 		if(soundPath.length() > MAX_SOUND_NAME_LENGTH) {
 			throw new RuntimeException("Sound Path is too long: '" + soundPath + "'!");
diff --git a/src/main/java/net/minecraft/core/util/helper/BlockParticleHelper.java b/src/main/java/net/minecraft/core/util/helper/BlockParticleHelper.java
index c6e247265..3e5f86a2f 100644
--- a/src/main/java/net/minecraft/core/util/helper/BlockParticleHelper.java
+++ b/src/main/java/net/minecraft/core/util/helper/BlockParticleHelper.java
@@ -1,16 +1,19 @@
 package net.minecraft.core.util.helper;
 
 public class BlockParticleHelper {
-    public static int encodeBlockData(int blockId, int meta, Side side){
+    public static int encodeBlockData(int blockId, int meta, Side side) {
         return blockId & 0x3FFF | (meta & 0xFF) << 14 | (side.getId() << 22);
     }
-    public static int decodeBlockID(int data){
+
+    public static int decodeBlockID(int data) {
         return data & 0x3FFF;
     }
-    public static int decodeBlockMeta(int data){
+
+    public static int decodeBlockMeta(int data) {
         return data >> 14 & 0xFF;
     }
-    public static int decodeBlockSide(int data){
-        return data >> 22 & 0xF;
+
+    public static Side decodeBlockSide(int data) {
+        return Side.getSideById(data >> 22 & 0xF);
     }
 }
diff --git a/src/main/java/net/minecraft/core/util/helper/GetMonsterSkinUrlThread.java b/src/main/java/net/minecraft/core/util/helper/GetMonsterSkinUrlThread.java
index 65158d110..2ba9d9fba 100644
--- a/src/main/java/net/minecraft/core/util/helper/GetMonsterSkinUrlThread.java
+++ b/src/main/java/net/minecraft/core/util/helper/GetMonsterSkinUrlThread.java
@@ -4,12 +4,15 @@ import com.b100.json.JsonParser;
 import com.b100.json.element.JsonArray;
 import com.b100.json.element.JsonObject;
 import com.b100.utils.StringUtils;
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.entity.monster.HumanMob;
+import org.slf4j.Logger;
 
 import java.util.Base64;
+import java.util.UUID;
 
 public class GetMonsterSkinUrlThread extends Thread{
-
+	private static final Logger LOGGER = LogUtils.getLogger();
 	private static int counter = 0;
 
 	private static final String urlUUID = "https://api.mojang.com/users/profiles/minecraft/";
@@ -18,7 +21,7 @@ public class GetMonsterSkinUrlThread extends Thread{
 	private static final JsonParser jsonParser = new JsonParser();
 
 	private HumanMob monster;
-	private String uuid;
+	private UUID uuid;
 
 	public GetMonsterSkinUrlThread(HumanMob monster) {
 		this.monster = monster;
@@ -32,7 +35,7 @@ public class GetMonsterSkinUrlThread extends Thread{
 	@Override
 	public void run() {
 		String name = monster.nickname;
-		if(name == null || name.length() == 0) return;
+		if(name == null || name.isEmpty()) return;
 
 		//  Attempt to get the skin 3 times before failing
 		String string = null;
@@ -59,8 +62,8 @@ public class GetMonsterSkinUrlThread extends Thread{
 				}
 			}
 		}
-		
-		System.out.println("Skin URL: "+ monster.skinUrl);
+
+        LOGGER.info("Skin URL: {}", monster.skinUrl);
 	}
 	
 	public static String decodeBase64(String string) {
@@ -68,31 +71,14 @@ public class GetMonsterSkinUrlThread extends Thread{
 	}
 	private String getSkinObject(String name){
 		String string;
-		try{
-			string = StringUtils.getWebsiteContentAsString(urlUUID + name);
-		}catch (Exception e) {
-			System.err.println("Can't connect to Mojang API.");
-			e.printStackTrace();
-			return null;
-		}
-		if(string.length() == 0) {
-			System.err.println("Player "+name+" doesn't exist!");
-			return null;
-		}
-		try {
-			JsonObject contentParsed = jsonParser.parse(string);
-			this.uuid = contentParsed.getString("id");
-		}catch (Exception e) {
-			e.printStackTrace();
-			return null;
-		}
-		if(uuid == null) return null;
+		this.uuid = UUIDHelper.getUUIDFromName(name);
+    if(uuid == null) return null;
 
-		System.out.println("Loading Skin for Player "+name+"...");
+        LOGGER.info("Loading Skin for Player {}...", name);
 		try {
 			string = StringUtils.getWebsiteContentAsString(urlSkin + uuid);
 		}catch (Exception e) {
-			System.err.println("Invalid UUID "+uuid+", or can't connect to the Mojang API.");
+            LOGGER.warn("Invalid UUID {}, or can't connect to the Mojang API.", uuid);
 			return null;
 		}
 		return string;
diff --git a/src/main/java/net/minecraft/core/util/helper/GetSkinUrlThread.java b/src/main/java/net/minecraft/core/util/helper/GetSkinUrlThread.java
index 02dfb01af..195f2af64 100644
--- a/src/main/java/net/minecraft/core/util/helper/GetSkinUrlThread.java
+++ b/src/main/java/net/minecraft/core/util/helper/GetSkinUrlThread.java
@@ -1,25 +1,28 @@
 package net.minecraft.core.util.helper;
 
 import java.util.Base64;
+import java.util.UUID;
 
 import com.b100.json.JsonParser;
 import com.b100.json.element.JsonArray;
 import com.b100.json.element.JsonObject;
 import com.b100.utils.StringUtils;
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.entity.player.Player;
+import org.slf4j.Logger;
 
 public class GetSkinUrlThread extends Thread{
-	
+	private static final Logger LOGGER = LogUtils.getLogger();
 	private static int counter = 0;
 
 	private static final String urlUUID = "https://api.mojang.com/users/profiles/minecraft/";
 	private static final String urlSkin = "https://sessionserver.mojang.com/session/minecraft/profile/";
 	
 	private static final JsonParser jsonParser = new JsonParser();
-	
+
 	private Player player;
-	private String uuid;
-	
+	private UUID uuid;
+
 	public GetSkinUrlThread(Player player) {
 		this.player = player;
 		
@@ -32,6 +35,7 @@ public class GetSkinUrlThread extends Thread{
 	@Override
 	public void run() {
 		String name = player.username;
+		this.uuid = player.uuid;
 		if(name == null || name.length() == 0) return;
 
 		//  Attempt to get the skin 3 times before failing
@@ -62,9 +66,9 @@ public class GetSkinUrlThread extends Thread{
 		if(texturesObject.has("CAPE")) {
 			player.capeURL = texturesObject.getObject("CAPE").getString("url");
 		}
-		
-		System.out.println("Skin URL: "+player.skinURL);
-		System.out.println("Cape URL: "+player.capeURL);
+
+        LOGGER.info("Skin URL: {}", player.skinURL);
+        LOGGER.info("Cape URL: {}", player.capeURL);
 	}
 	
 	public static String decodeBase64(String string) {
@@ -72,31 +76,16 @@ public class GetSkinUrlThread extends Thread{
 	}
 	private String getSkinObject(String name){
 		String string;
-		try{
-			string = StringUtils.getWebsiteContentAsString(urlUUID + name);
-		}catch (Exception e) {
-			System.err.println("Can't connect to Mojang API.");
-			e.printStackTrace();
-			return null;
-		}
-		if(string.length() == 0) {
-			System.err.println("Player "+name+" doesn't exist!");
-			return null;
-		}
-		try {
-			JsonObject contentParsed = jsonParser.parse(string);
-			this.uuid = contentParsed.getString("id");
-		}catch (Exception e) {
-			e.printStackTrace();
-			return null;
+		if (uuid == null) {
+			uuid = UUIDHelper.getUUIDFromName(name);
+			if(uuid == null) return null;
 		}
-		if(uuid == null) return null;
 
-		System.out.println("Loading Skin for Player "+name+"...");
+        LOGGER.info("Loading Skin for Player {}...", name);
 		try {
 			string = StringUtils.getWebsiteContentAsString(urlSkin + uuid);
 		}catch (Exception e) {
-			System.err.println("Invalid UUID "+uuid+", or can't connect to the Mojang API.");
+            LOGGER.warn("Invalid UUID {}, or can't connect to the Mojang API.", uuid);
 			return null;
 		}
 		return string;
